clear;global q p p0 x0 omega; clc;

load u:\research\nonparametric_demand\January\saved\replicate\idq.txt;
load u:\research\nonparametric_demand\January\saved\replicate\idp.txt;    
load u:\research\nonparametric_demand\January\saved\replicate\idp0.txt; 
load u:\research\nonparametric_demand\January\saved\replicate\idx0.txt; 
load u:\research\nonparametric_demand\January\saved\replicate\idq0.txt; 
load u:\research\nonparametric_demand\January\saved\replicate\idvar.txt; 
load u:\research\nonparametric_demand\January\saved\replicate\iwstart.txt; 

p  = idp;
p0 = idp0;
x0 = idx0;
q0 = idq0;
wstart  = iwstart;
good = 1;

% Choose the kears you want to keep

keep = [75:77 79 82:86 89 90 91]-74;
keep = [75:77 79 82:86 89 90 91 [78 87 88 93:94 95 96:99]]-74;

keep = [75:99]-74;
keep = [82:91]-74;
%keep = [82:91 93:95]-74;
keep = sort(keep);
K = size(p,1);
N = size(p0,2);
T = length(keep);

p     = p(:,keep);
idq   = idq(:,keep);
vkeep = (ones(K-1,1)*(keep*(K-1)))'-(ones(length(keep),1)*(0:K-2));
vkeep = sort(vkeep(:));
idvar = idvar(:,vkeep);


UpperBounds = NaN*ones(K,N);
LowerBounds = NaN*ones(K,N);
uVu         = NaN*ones(1,N);
for n=8;
    q        = idq((n*K)-(K-1):n*K,:);

    variance = idvar((n*(K-1))-(K-2):n*(K-1),:);
    for t=1:T;
        if t==1;            
            omega = variance(:,((t*(K-1))-(K-1)+1):t*(K-1)); 
        else;
            omega = blkdiag(omega,variance(:,((t*(K-1))-(K-1)+1):t*(K-1))); 
        end;
    end;
    
    p0 = idp0(:,n);
    if garp(p,q)==0;
        x = (x0*ones(1,T))./sum(p0*ones(1,T).*(wstart*ones(1,T)./p));
        qStart = ((wstart*ones(1,T)).*(ones(K,1)*x))./p;
        lb = 0;
        Aeq = zeros(K*T,K*T);
        Beq = zeros(K*T,1);
        for t=1:T;
            Aeq(t,((t-1)*K)+1:t*K)=p0';
            Beq(t) = x0;
        end;
        
        options=optimset('Display','iter','Diagnostics','off','MaxFunEvals',1000,'TolCon',1e-006,'MaxIter',5);

         [x,fval,exitflag,output]=fmincon(@WeightedEuclideanDistanceKminus1,qStart(:),[],[],Aeq,Beq,lb,[],@GARPConstraint,options);

         
% Comment this back in to keep and draw the pertubations in the middle (n=8 here) of the demand curve which
% correspond to those in Figure 7 in the paper

%          if n==8;
%             % Keep the perturbation for the real data
%             E = reshape(x,K,T)-q;
%             se = sqrt(diag(omega));
%             se = reshape(se,2,T);
%             se=[se;NaN*ones(1,T)];
%             for t=1:T;
%                 se(3,t)=sqrt((p([1 2],t)'./p(3,t))*omega([(t*(K-1))-1 t*(K-1)],[(t*(K-1))-1 t*(K-1)])*(p([1 2],t)./p(3,t)));
%             end;
% 
% 
%             xxx = 75:99;
%             ss = 5:2:20;
%             plot(75:99,E(1,:)','k-',xxx(ss),1.96*se(1,ss)'+E(1,ss)','k.',xxx(ss),-1.96*se(1,ss)'+E(1,ss)','k.',...
%                  75:99,E(2,:)','r-.',xxx(ss),1.96*se(2,ss)'+E(2,ss)','r+',xxx(ss),-1.96*se(2,ss)'+E(2,ss)','r+',...
%                  75:99,E(3,:)','b--',xxx(ss),1.96*se(3,ss)'+E(3,ss)','bx',xxx(ss),-1.96*se(3,ss)'+E(3,ss)','bx');                 
%            
%         stop;
%             
%         end;

         q = reshape(x,K,T);
         
         
         
         
    end;

    for k=1:K;
        A = p';
        B = diag(p'*q);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%        
% Some old code but could be used to force downward sloping demand curves if required %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%         if n>1;% & k==good;
%              Adown = zeros(1,K);
%              Adown(k)=-1;
%              Bdown=-UpperBounds(k,n-1);
%              A = [A;Adown];
%              B = [B;Bdown];
%              
%         end;
        Aeq = p0';
        Beq = x0;
        f = zeros(1,K);
        f(k)=1;
        options=optimset('Display','off','TolCon',0,'MaxIter',100);
        [x,fval,exitflag,output,lambda] = linprog(f,-A,-B,Aeq,Beq,zeros(K,1),[],[],options);
        LowerBounds(k,n)=x(k);
        [x,fval,exitflag,output,lambda] = linprog(-f,-A,-B,Aeq,Beq,zeros(K,1),[],[],options);
        UpperBounds(k,n)=x(k);
    end;

end;
bounds = [LowerBounds' UpperBounds'];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Draws the Figure 3 in the paper % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p0 = idp0;
[k]=convhull(p(1,:)',p(3,:)');
figure; plot(idp(1,:),idp(3,:),'k.',p0(1,:),p0(3,:),'k+',p(1,k),p(3,k),'k-');
text(idp(1,1)+0.001,idp(3,1),'75','FontSize',12);
text(idp(1,2)+0.001,idp(3,2),'76','FontSize',12);
text(idp(1,3)+0.001,idp(3,3),'77','FontSize',12);
text(idp(1,4)+0.001,idp(3,4),'78','FontSize',12);
text(idp(1,5)+0.001,idp(3,5),'79','FontSize',12);
text(idp(1,6)+0.001,idp(3,6),'80','FontSize',12);
text(idp(1,7)+0.001,idp(3,7),'81','FontSize',12);
text(idp(1,8)+0.001,idp(3,8),'82','FontSize',12);
text(idp(1,9)-0.01,idp(3,9)-0.01,'83','FontSize',12);
text(idp(1,10)+0.001,idp(3,10),'84','FontSize',12);
text(idp(1,11)+0.001,idp(3,11),'85','FontSize',12);
text(idp(1,12)+0.001,idp(3,12),'86','FontSize',12);
text(idp(1,13)+0.001,idp(3,13),'87','FontSize',12);
text(idp(1,14)-0.009,idp(3,14),'88','FontSize',12);
text(idp(1,15)+0.001,idp(3,15),'89','FontSize',12);
text(idp(1,16)+0.001,idp(3,16),'90','FontSize',12);
text(idp(1,17)+0.001,idp(3,17),'91','FontSize',12);
text(idp(1,18)-0.009,idp(3,18),'92','FontSize',12);
text(idp(1,19)+0.001,idp(3,19),'93','FontSize',12);
text(idp(1,20)+0.001,idp(3,20),'94','FontSize',12);
text(idp(1,21)+0.001,idp(3,21),'95','FontSize',12);
text(idp(1,22)+0.001,idp(3,22),'96','FontSize',12);
text(idp(1,23)+0.001,idp(3,23),'97','FontSize',12);
text(idp(1,24)+0.001,idp(3,24),'98','FontSize',12);
text(idp(1,25)+0.001,idp(3,25),'99','FontSize',12);
xlabel('Price of Food')
ylabel('Price of Services')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Draws the bounds on each demand curve e.g. Figure 4,5,6 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure; plot(100*((idp0(1,:)./mean(idp(1,:)'))-1),bounds(:,[1 4]),'k');
figure; plot(100*((idp0(1,:)./median(idp0(1,:)))-1),bounds(:,[2 5]),'k');
figure; plot(100*((idp0(1,:)./median(idp0(1,:)))-1),bounds(:,[3 6]),'k');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Save the Bounds points for drawing later %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%save 'x:\research\nonparametric_demand\January\saved\Median25' bounds;