function uu = WeightedEuclideanDistanceKminus1(x);
% Takes all K goods and returns u'inverse(omega)*u where u = vec(x-q) using K-1 
% goods and K-1 variance-covariance matrix (because the KxK VarCov matrix <
% full rank

global p q omega;

x = reshape(x,length(x)/size(p,2),size(p,2)); % reshape current q's to KxT
x = x(1:(size(p,1)-1),:); % lop off last good
qlocal = q(1:(size(p,1)-1),:);
u  = x(:)-qlocal(:); 
uu = u'*inv(omega)*u;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%