
new; format /rd;   y = csrtype(0); format 4,0; library pgraph; cls;
#include x:\\research\\gauss_functions\\garpproc.prc;
_pset = "x:\\research\\nonparametric_demand\\January\\saved";
load path = ^_pset; 
_pset = "x:\\research\\nonparametric_demand\\January\\saved";
save path = ^_pset;

starty = 75;
stopy  = 99;
npoints = 49;
t = starty;
DO UNTIL t>stopy;
    dat1 = "x:\\research\\nonparametric_demand\\data\\data"$+FTOS((t), "%*.*lf" ,1,0);
    OPEN f1 = ^dat1 VARINDXI;
    data = READR(f1,rowsf(f1));
    names = GETNAME(dat1);
    
    locate 1,1;"Estimating using ";;dat1;
    week = data[.,iweek];
    cars = data[.,incars].>0;
    smoker = (data[.,icigs]+data[.,iothtob]).>0;
    sel    = (data[.,icouple] .and data[.,inumhhkid].>0 .and cars.==1);
    data   = SELIF(data,sel);
    data   = SELIF(data,data[.,itotexp].>0);
    data   = SELIF(data,data[.,ihhincome].>0);

    x = data[.,ibread:iothtob]~data[.,irent:idiy]~
        data[.,icoal:ientertai];

    wnames=names[ibread:iothtob irent:idiy icoal:ientertai];
    /**********
    01    BREAD     21 POTATOES     41  FURNISH     61 RAILFARE
    02  CEREALS     22 OTH_VEGS     42 ELEC_APP     62 BUSFARES
    03 BISCUITS     23    FRUIT     43  OTHHHEQ     63  OTHTRAV
    04     BEEF     24 OTH_FOOD     44  CONSUMA     64  AUD_VIS
    05     LAMB     25  CANTEEN     45  PETCARE     65 REC_TOYS
    06     PORK     26 OTH_SNAC     46  POSTAGE     66 BOOK_NEW
    07    BACON     27     BEER     47 TELEPHON     67   GARDEN
    08 POUL_OTH     28 WINESPIR     48 DOMSERVS     68  TVLICEN
    09     FISH     29     CIGS     49 FEES_SUB     69 ENTERTAI
    10   BUTTER     30   OTHTOB     50 MENOUTER     
    11 OIL_FATS     31     RENT     51 WOMOUTER
    12   CHEESE     32 MORTGAGE     52 KIDOUTER
    13     EGGS     33 RATESETC     53 OTHCLOTH
    14 MILKFRES     34   REPAIR     54 FOOTWEAR
    15 MILKPROD     35      DIY     55 CHEMGOOD
    16      TEA     36     COAL     56  P_SERVS
    17   COFFEE     37 ELECTRIC     57 MOTORVEH
    18 SOFTDRIN     38      GAS     58 MAINTMOT
    19 SUG_PRES     39  OIL_OTH     59  PET_OIL
    20 SWE_CHOC     40   FURNIT     60  TAX_INS     ***********/
 
    
    nondurables = seqa(1,1,30)|36|37|38|39|seqa(44,1,13)|seqa(58,1,12);

    g1 = seqa(1,1,24);                          /* Food in */
    g2 = seqa(25,1,2);                          /* Food out */
    g3 = seqa(27,1,4);                          /* Booze n Fags */
    g4 = 44|45|seqa(50,1,6)|seqa(64,1,4);       /* nondurable goods */
    g5 = seqa(36,1,4)|seqa(46,1,4)|56|68|69;    /* services */
    g6 = seqa(58,1,3)|seqa(61,1,3);             /* travel   */


    g1 = sortc(g1|g2,1);                /* Food */
    g2 = sortc(g3|g4,1);                /* Goods */
    g3 = sortc(g5|g6,1);                /* Services */ 
   
    x    = x.*(x.>=0);                  /* Budget shares */
    ws   = sumc(x[.,nondurables]');     /* Sum of budget shares */
    z    = data[.,inumhhkid];
    totx = data[.,itotexp].*ws;
    inc  = data[.,ihhincome];
    
    scale   = 1+(0.29*z);
    totx    = totx./scale;
    inc     = inc./scale;        
    
    xx   = sortc(totx,1); yy   = sortc(inc,1);
    
    sel  = (totx.>0) .and (inc.>0) .and
        /* (totx.>=xx[round(0.01.*rows(xx))]) .AND*/
           (totx.<=xx[round(0.99.*rows(xx))]) .and 
        /* (inc.>=yy[round(0.01.*rows(yy))]) .AND*/
           (inc.<=yy[round(0.99.*rows(yy))]);

    x       = selif(x,sel);     /* Budget shares */
    y       = selif(inc,sel);  /* Eq income */       
    ws      = selif(ws,sel);    /* percent budget on nondurables*/
    totx    = selif(totx,sel);   /* tox on nodura */
    z       = selif(z,sel);      /* num kids */    
    w       = x./ws;            /* Rescale budget shares */
    
    
    wg = sumc(w[.,g1]')~sumc(w[.,g2]')~sumc(w[.,g3]');/*~
         sumc(w[.,g4]')~sumc(w[.,g5]')~sumc(w[.,g6]');*/
    
    wg = wg[.,1:cols(wg)-1]~(wg[.,cols(wg)]+(1-sumc(wg')));
    wg = wg[.,1:cols(wg)-1]~(wg[.,cols(wg)]+(1-sumc(wg')));

    /*********************/
    /* Normalise x and y */
    /*********************/
    
    load norm;
    totx = totx./norm[t-74];
    y = y./norm[t-74];

    w   = wg;
    lnx = ln(totx);
    lny = ln(y);
 
    /*************************/
    /* OLS : lnx = alny + bz */
    /*************************/

    yy = lnx; 
    xx = lny~z;
    u = (xx*(invpd(xx'xx)*xx'yy))-yy; 

    clear xx,yy,wg;
    
    hfac = 1.059;
    h    = hfac*stdc(lnx)*(rows(lnx)^-0.2);
    hp = h/4;
    
    /****************/
    /* Pilot kernel */
    /****************/    

    j = 1;
    DO UNTIL j > rows(lnx);
        IF j == 1;
            fx = meanc(PDFN((lnx[j]-lnx)/hp)/hp);
        ELSE;
            fx = fx|meanc(PDFN((lnx[j]-lnx)/hp)/hp);
            ENDIF;
        j = j + 1;
    ENDO;

    _alpha = 1/5;   gamm = exp(meanc(ln(fx)));  lambda = (fx./gamm).^(-_alpha);

    /*******************************/
    /* Adaptive kernel regressions */
    /*  1. E(w|lnx)                */
    /*  2. E(u|lnx)                */
    /*  3. E(z|lnx)                */    
    /*******************************/    
  
    i = 1;
    DO UNTIL i > rows(lnx);
        f      = PDFN((lnx[i]-lnx)./(h.*lambda))./(h.*lambda);
        Ewlnxi = (meanc(f.*w))./(meanc(f));
        Eulnxi = (meanc(f.*u))./(meanc(f));
        Ezlnxi = (meanc(f.*z))./(meanc(f));
        IF i == 1;
            Ewlnx = Ewlnxi;
            Eulnx = Eulnxi;
            Ezlnx = Ezlnxi;
        ELSE;
            Ewlnx = Ewlnx~Ewlnxi;
            Eulnx = Eulnx~Eulnxi;
            Ezlnx = Ezlnx~Ezlnxi;
        ENDIF;
        i = i + 1;
    ENDO;

    /********************************************************/
    /* OLS : w-E(w|lnx) = a(v-E(v|lnX)) + b(z-E(z|lnx))     */
    /********************************************************/

    dep    = (w-Ewlnx');
    indep  = (u-Eulnx')~(z-Ezlnx');
    b      = INVPD(indep'indep)*(indep'dep);

    v      = dep-(indep*b);
    seb    = sqrt(diag(((v'v)./rows(v)).*.(INVPD(indep'indep))));
    seb    = (reshape(seb,cols(dep),cols(indep)))';

    _w_    = w-(u.*b[1,.])-(z*b[2,.]);
    
    lnxgrid = seqa(minc(lnx),(maxc(lnx)-minc(lnx))./100,101);
    
    h      = 1.059*stdc(lnx)*(rows(lnx)^-0.2);
    ii = 1;
    DO UNTIL ii>rows(lnxgrid);
        Kh     = PDFN((lnxgrid[ii]-lnx)./(h.*lambda));
        f      = Kh./(h.*lambda);
        IF ii==1;
        flnx   = ((meanc(f.*_w_))./(meanc(f)))';
        ELSE;
        flnx   = flnx|(((meanc(f.*_w_))./(meanc(f))))'; 
        ENDIF;
        ii=ii+1;
    ENDO;
         
    ldat = w~lnx~lny~z~_w_~lambda;


    x = sortc(exp(lnx),1);
    
    if t==starty;
        xstats = (minc(x)|maxc(x)|meanc(x)|x[round(rows(x).*seqa(0.05,0.05,19))])|rows(x);
        zstats = (minc(z)|maxc(z)|meanc(z));
        wstats = meanc(w);
        beta   = b';
        keepx = sortc(x,1);
    ELSE;
        xstats = xstats~(minc(x)|maxc(x)|meanc(x)|x[round(rows(x).*seqa(0.05,0.05,19))]|rows(x));
        zstats = zstats~(minc(z)|maxc(z)|meanc(z));
        wstats = wstats~meanc(w);
        beta   = beta~b';
        keepx = keepx|sortc(x,1);
    endif;
    
    f1 = close(f1);
    fname = "LDAT"$+FTOS((t), "%*.*lf" ,1,0);
    save ^fname = ldat;
    t = t + 1;
endo;
keepx = sortc(keepx,1);
ng = cols(w);
nt = t-starty;
xstats = xstats~(minc(keepx)|maxc(keepx)|meanc(keepx)|keepx[round(rows(keepx).*seqa(0.05,0.05,19))]|rows(keepx)); 
save xstats;
save zstats;
save wstats;
save beta;
save ng, nt;
save starty;
save stopy;
cls;
END;

