new; format /rd;   y = csrtype(0); format 4,0; library pgraph; cls;
#include x:\\research\\gauss_functions\\garpproc.prc;

save path = "x:\\research\\nonparametric_demand\\January\\saved\\1in5";

r = 1;   
do until r>251;  /*    Choose the number of resamples here */
    locate 1,1;"Resample ";;r;

    starty = 75;
    stopy  = 99;
    npoints = 49;
    t = starty;
    do until t>stopy;
        locate 1,1;"Resample ";;r;
        dat1 = "x:\\research\\nonparametric_demand\\data\\data"$+FTOS((t), "%*.*lf" ,1,0);
        open f1 = ^dat1 VARINDXI;

        data = READR(f1,rowsf(f1));

        names = GETNAME(dat1);

        week = data[.,iweek];
        cars = data[.,incars].>0;
        smoker = (data[.,icigs]+data[.,iothtob]).>0;
        sel    = (data[.,icouple] .and data[.,inumhhkid].>0 .and cars.==1);
        data   = SELIF(data,sel);
        data   = SELIF(data,data[.,itotexp].>0);
        data   = SELIF(data,data[.,ihhincome].>0);
    
        /* RESAMPLE WITH REPLACMENT HERE */
        if r>1;
            u = rndu(rows(data),1); 
            u = round((u*rows(data))+0.5);
            u = u[1:round((rows(data)*0.2))];    /* choose resample rate */
            data = data[u,.];
        endif;

    
/*        if r>1;
            u = round((rndu(rows(data),1)*rows(data))+0.5); 
            data = data[u,.];
        endif;*/
    
        x = data[.,ibread:iothtob]~data[.,irent:idiy]~
            data[.,icoal:ientertai];
    
            wnames=names[ibread:iothtob irent:idiy icoal:ientertai];
            nondurables = seqa(1,1,30)|36|37|38|39|seqa(44,1,13)|seqa(58,1,12);
    
        g1      = seqa(1,1,24);                          /* Food in */
        g2      = seqa(25,1,2);                          /* Food out */
        g3      = seqa(27,1,4);                          /* Booze n Fags */
        g4      = 44|45|seqa(50,1,6)|seqa(64,1,4);       /* nondurable goods */
        g5      = seqa(36,1,4)|seqa(46,1,4)|56|68|69;    /* services */
        g6      = seqa(58,1,3)|seqa(61,1,3);             /* travel   */
        g1      = sortc(g1|g2,1);                /* Food */
        g2      = sortc(g3|g4,1);                /* Goods */
        g3      = sortc(g5|g6,1);                /* Services */ 
        x       = x.*(x.>=0);                  /* Budget shares */
        ws      = sumc(x[.,nondurables]');     /* Sum of budget shares */
        z       = data[.,inumhhkid];
        totx    = data[.,itotexp].*ws;
        inc     = data[.,ihhincome];
        scale   = 1+(0.29*z);
        totx    = totx./scale;
        inc     = inc./scale;        
        xx      = sortc(totx,1); yy   = sortc(inc,1);
        sel     = (totx.>0) .and (inc.>0) .and
                (totx.<=xx[round(0.99.*rows(xx))]) .and 
                (inc.<=yy[round(0.99.*rows(yy))]);
        
        x       = selif(x,sel);     /* Budget shares */
        y       = selif(inc,sel);  /* Eq income */       
        ws      = selif(ws,sel);    /* percent budget on nondurables*/
        totx    = selif(totx,sel);   /* tox on nodura */
        z       = selif(z,sel);      /* num kids */    
        w       = x./ws;            /* Rescale budget shares */
        wg      = sumc(w[.,g1]')~sumc(w[.,g2]')~sumc(w[.,g3]');
        wg      = wg[.,1:cols(wg)-1]~(wg[.,cols(wg)]+(1-sumc(wg')));
        wg      = wg[.,1:cols(wg)-1]~(wg[.,cols(wg)]+(1-sumc(wg')));
        
        w   = wg;
        /*********************/
        /* Normalise x and y */
        /*********************/
    
        load path = "x:\\research\\nonparametric_demand\\January\\saved";
        load norm;
        totx = totx./norm[t-74];
        y = y./norm[t-74];

        lnx = ln(totx);
        lny = ln(y);
     
        /*************************/
        /* OLS : lnx = alny + bz */
        /*************************/
    
        yy = lnx; 
        xx = lny~z;
        u = (xx*(invpd(xx'xx)*xx'yy))-yy; 
    
        clear xx,yy,wg;
        
        hfac = 1.059;
        h    = hfac*stdc(lnx)*(rows(lnx)^-0.2);
        hp = h/4;
        
        /****************/
        /* Pilot kernel */
        /****************/    
    
        j = 1;
        do until j > rows(lnx);
            if j == 1;
                fx = meanc(PDFN((lnx[j]-lnx)/hp)/hp);
            else;
                fx = fx|meanc(PDFN((lnx[j]-lnx)/hp)/hp);
                endif;
            j = j + 1;
        endo;
    
        _alpha = 1/5;   gamm = exp(meanc(ln(fx)));  lambda = (fx./gamm).^(-_alpha);
    
        /*******************************/
        /* Adaptive kernel regressions */
        /*  1. E(w|lnx)                */
        /*  2. E(u|lnx)                */
        /*  3. E(z|lnx)                */    
        /*******************************/    
      
        i = 1;
        do until i > rows(lnx);
            f      = PDFN((lnx[i]-lnx)./(h.*lambda))./(h.*lambda);
            Ewlnxi = (meanc(f.*w))./(meanc(f));
            Eulnxi = (meanc(f.*u))./(meanc(f));
            Ezlnxi = (meanc(f.*z))./(meanc(f));
            if i == 1;
                Ewlnx = Ewlnxi;
                Eulnx = Eulnxi;
                Ezlnx = Ezlnxi;
            else;
                Ewlnx = Ewlnx~Ewlnxi;
                Eulnx = Eulnx~Eulnxi;
                Ezlnx = Ezlnx~Ezlnxi;
            endif;
            i = i + 1;
        endo;
    
        /********************************************************/
        /* OLS : w-E(w|lnx) = a(v-E(v|lnX)) + b(z-E(z|lnx))     */
        /********************************************************/
    
        dep    = (w-Ewlnx');
        indep  = (u-Eulnx')~(z-Ezlnx');
        b      = INVPD(indep'indep)*(indep'dep);
    
        v      = dep-(indep*b);
        seb    = sqrt(diag(((v'v)./rows(v)).*.(INVPD(indep'indep))));
        seb    = (reshape(seb,cols(dep),cols(indep)))';
    
        _w_    = w-(u.*b[1,.])-(z*b[2,.]);
        
        lnxgrid = seqa(minc(lnx),(maxc(lnx)-minc(lnx))./100,101);
        
        h      = 1.059*stdc(lnx)*(rows(lnx)^-0.2);
        ii = 1;
        do until ii>rows(lnxgrid);
            Kh     = PDFN((lnxgrid[ii]-lnx)./(h.*lambda));
            f      = Kh./(h.*lambda);
            if ii==1;
            flnx   = ((meanc(f.*_w_))./(meanc(f)))';
            else;
            flnx   = flnx|(((meanc(f.*_w_))./(meanc(f))))'; 
            endif;
            ii=ii+1;
        endo;
            
        ldat = w~lnx~lny~z~_w_~lambda;

        x = sortc(exp(lnx),1);
        if t==starty;
            xstats = (minc(x)|maxc(x)|meanc(x)|x[round(rows(x).*seqa(0.05,0.05,19))])|rows(x);
            zstats = (minc(z)|maxc(z)|meanc(z));
            wstats = meanc(w);
            beta   = b';
            keepx = sortc(x,1);
        else;
            xstats = xstats~(minc(x)|maxc(x)|meanc(x)|x[round(rows(x).*seqa(0.05,0.05,19))]|rows(x));
            zstats = zstats~(minc(z)|maxc(z)|meanc(z));
            wstats = wstats~meanc(w);
            beta   = beta~b';
            keepx = keepx|sortc(x,1);
        endif;
        
        f1 = close(f1);
        fname = "LDAT"$+FTOS((t), "%*.*lf" ,1,0);
        save ^fname = ldat;

        t = t + 1;
    endo;


    keepx = sortc(keepx,1);
    ng = cols(w);
    nt = t-starty;
    if r==1;
        xstats = xstats~(minc(keepx)|maxc(keepx)|meanc(keepx)|keepx[round(rows(keepx).*seqa(0.05,0.05,19))]|rows(keepx));
        save wstats;
        save xstats;
    endif;
    clear q,qsol,q0,qatx0,qvariance;
    
    load wstats, xstats, p;

    format /rd 8,4;
    
    zbeta = beta[.,seqa(2,2,cols(zstats))];
    _fcmptol = 1e-8;

    load path = "x:\\research\\nonparametric_demand\\January\\saved";                                                                                                                                                      
    load pnorm;
    p = pnorm;
    pstar = meanc(p[.,1:25]');    

    x0    = xstats[13,cols(xstats)];
    good   = 1;
    others = setdif(seqa(1,1,rows(p)),good,1);
    p0 = pstar;

    gosub GetIntersection; 
    if sumc(sumc(missrv(q,-pi).==-pi))>0;
        stop;
    endif;
       

    if r==1;    
        qout=q;         
        p0out = p0; 
        var = qvariance; 
        format /rd 16,16;
        outwidth(256);
        output file = "x:\\research\\nonparametric_demand\\January\\saved\\1in5\\idp.txt";
        output reset;
        output on;
        p;
        output off;
    else;       
        qout=qout|q;    
        p0out = p0out~p0; 
        var = var|qvariance;
    endif;

    r=r+1;
endo;

format /rd 16,16;
outwidth(256);
output file = "x:\\research\\nonparametric_demand\\January\\saved\\1in5\\idq.txt";
output reset;
output on;
qout;
output off;

output file = "x:\\research\\nonparametric_demand\\January\\saved\\1in5\\idp.txt";
output reset;
output on;
p;
output off;

output file = "x:\\research\\nonparametric_demand\\January\\saved\\1in5\\idp0.txt";
output reset;
output on;
p0;
output off;

output file = "x:\\research\\nonparametric_demand\\January\\saved\\1in5\\idx0.txt";
output reset;
output on;
x0;
output off;

output file = "x:\\research\\nonparametric_demand\\January\\saved\\1in5\\idvar.txt";
output reset;
output on;
var;
output off;

load wstats;
output file = "x:\\research\\nonparametric_demand\\January\\saved\\1in5\\iwstart.txt";
output reset;
output on;
meanc(wstats');
output off;

output file = "x:\\research\\nonparametric_demand\\January\\saved\\1in5\\g.txt";
output reset;
output on;
good;
output off;

end;
    
/********************************************************************/
/********************************************************************/
/********************************************************************/
GetIntersection:
    q=zeros(rows(p),cols(p));                                                                                                                                                        
    x=zeros(cols(p),1);                                                                                                                                                         
    t = starty;                                                                                                                                                                
    do until t>stopy;                                                                                                                                                         
        col = t-(starty-1);                                                                                                                                                        
        clear ldat;  
        load path = "x:\\research\\nonparametric_demand\\January\\saved\\1in5\\";                                                                                                                                                      
        fname = "LDAT"$+FTOS((t), "%*.*lf" ,1,0);                                                                                                                          
        loadm ldat = ^fname;                                                                                                                                               
        w      = LDAT[.,1:rows(p)];

        _w_    = LDAT[.,(rows(p)+3)+1:(rows(p)+3)+rows(p)];                                                                                                                               
        lambda = LDAT[.,cols(LDAT)];                                                                                                                                       
        lnx    = LDAT[.,rows(p)+1];                                                                                                                                             
        h      = 2*1.059*stdc(lnx)*(rows(lnx)^-0.2);                                                                                                                       
        np 	   = 100; 
		x0grid = sortc(exp(lnx)|x0,1);   /* This is a fix because of extrapolation */                                                                                                                                                       
        x0grid = x0grid[1]|x0grid[round(seqa(1/np,1/np,np-1).*rows(lnx))]|x0grid[rows(lnx)];                                                                               
        flnx   = zeros(rows(x0grid),rows(p));                                                                                                                                   
        i = 1;                                                                                                                                                             
        do until i>rows(x0grid);                                                                                                                                           
            Kh     = PDFN((ln(x0grid[i])-lnx)./(h.*lambda));                                                                                                               
            f      = Kh./(h.*lambda);                                                                                                                                      
            flnx[i,.]   = ((meanc(f.*_w_))./(meanc(f)))';                                                                                                                  
            i = i+1;                                                                                                                                                       
        endo;                                                                                                                                                              
        wt     = flnx+(zbeta[.,col]*2)';                                                                                                                       
        qt     = (wt.*x0grid)./p[.,col]';                                                                                                                                  
        x[col] = linterp((p0'(qt'))',x0grid,x0);                                                                                                                           
        Kh     = PDFN((ln(x[col])-lnx)./(h.*lambda));                                                                                                                      
        f      = Kh./(h.*lambda);                                                                                                                                          
        flnx   = ((meanc(f.*_w_))./(meanc(f)));                                                                                                                            
        what   = flnx+(zbeta[.,col]*2);                                                                                                                        
        
        sigma = zeros(rows(what),rows(what));
        m = 1;
        do until m > rows(what);
            n = 1;
            do until n > rows(what);
                sigma[m,n]  = meanc((f./meanc(f)).*( (w[.,m]-what[m]).*(w[.,n]-what[n]) ) );
                n = n + 1;
            endo;
            m = m + 1;
        endo;
        sigma   =  (sigma+sigma')/2; 
        wvariance = (sigma*0.282094792)./(rows(f)*h*meanc(f));
        wvariance = (wvariance+wvariance')/2;
        if t==starty;
            /*qvariance = ((x[col]./p[.,col])*~eye(rows(p)))*wvariance*((x[col]./p[.,col])*~eye(rows(p)))';*/
            qvariance = ((x[col]./p[1:(rows(p)-1),col])*~eye(rows(p)-1))*wvariance[1:(rows(p)-1),1:(rows(p)-1)]*((x[col]./p[1:(rows(p)-1),col])*~eye(rows(p)-1))';
            
        else;
            /*qvariance = qvariance~(((x[col]./p[.,col])*~eye(rows(p)))*wvariance*((x[col]./p[.,col])*~eye(rows(p)))');    */
            qvariance = qvariance~((x[col]./p[1:(rows(p)-1),col])*~eye(rows(p)-1))*wvariance[1:(rows(p)-1),1:(rows(p)-1)]*((x[col]./p[1:(rows(p)-1),col])*~eye(rows(p)-1))';
        endif;
            
        q_     = what.*x[col]./p[.,col];                                                                                                                                      
        q_[rows(q_)]=q_[rows(q_)]-((p0'q_-x0)./p0[rows(q_)]);
        q[.,col]=q_;
        t = t + 1;                                                                                                                                                         
    endo;                                                                                                                                                                  
return;
